/*************************************************************************
*	UGOKUZANSU PLAYER on system gPrideh version II
*************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	<egb.h>
#include	<snd.h>

#define	_ZNS_MAIN
#include	"znsplay.h"
#include	"../DLL/BGM/midi.h"
#include	<fdl.h>
#include	<MNU/mnu010.h>	/* j[Fݒ	*/

ZNSMOVE_T	ZnsMove =
{
	ZNS_MODE_MEMORY,	/* mode		*/
	0,					/* wait		*/
	2,					/* expand	*/
	-1,					/* type		*/
	""					/* filename	*/
};
FDL_T		*ZnsFdl = NULL;	/* t@C_CAO		*/
FDL_T		*BgmFdl = NULL;	/* BGMpt@C_CAO	*/

enum	_main_evt
{
	_EVT_NOTHING,
	_EVT_SIDEWORK,
	_EVT_MAIN_EXIT,
	_EVT_NUM,
};

/*	VXesɏ\	*/
void	zns_dsp_info(void)
{
	if ( ZnsMove.filename[0] == '\0' )
	{
		SYL_clear();
		return;
	}

	char		tmp[128];

	FS_getFnamPath(tmp,ZnsMove.filename );
	DSP_writePage(1);
	SYL_puts( C_INFO, "filename:%-12s wait:%2d, display:~%d, mode:%s",
	    tmp,
	    ZnsMove.wait,
	    ZnsMove.expand,
	    ZnsMove.mode == ZNS_MODE_MEMORY ? "memory": "disk"
	);
}

/* j[p̃J[e[uݒ	*/
void	setMenuCol( MNU_T *mnu )
{
	if ( mnu )
	{
		MNUCOL_TIT(mnu) = C_GRAY0;
		MNUCOL_STR(mnu) = C_METAL2;
		MNUCOL_BAC(mnu) = C_GRAY0;
		MNUCOL_BTN(mnu) = DspCtrl.black;
		MNUCOL_PSH(mnu) = C_GRAY1;
		MNUCOL_HIL(mnu) = C_GRAY3;
		MNUCOL_SHA(mnu) = C_GRAY1;
		MNUCOL_IGN(mnu) = C_GRAY1;
	}
}

/*************************************************************************
*	about ZNSPLAY
*************************************************************************/

int		APL_about(int evtNo, EVTSBJ_T *sbj)
{
	char	ver[32];

	sprintf( ver, "%s edition #%s", MAIN_VER, EDITION_NUMBER );
	Apl_dlgMsg( 8, 32, ver, _ZNSPLAY_,
	    "%s %s compiled.\n(C)Copyright 1993, H.Toda & TaroPYON\n",
	    __DATE__, __TIME__ );
	return (_EVT_NOTHING);
}

static UINT		get_freemem(void)	/* eʂ𒲂ׂ	*/
{
	int		mx;
	UINT	sz, fm;
#define	TBL_MAX	(256)
	char	*dmy[TBL_MAX];

	for ( sz = 0x100000, fm = mx = 0 ; mx < TBL_MAX; ++mx )
	{
		while ( (dmy[mx] = malloc((size_t)sz)) == NULL )
		{	if ( (sz /= 2) < 0x100 )
				break;
		}
		if ( dmy[mx] == NULL )
			break;
		fm += sz;
	}
	while ( mx > 0 )
		free( dmy[--mx] );
	return	(fm);
}

/*************************************************************************
*	t[̕\
*************************************************************************/
int		APL_freeMem(int evtNo, EVTSBJ_T *sbj)
{
	UINT	f;
	char	tmp[32];

	f = get_freemem();
	GetSizeStr(f,tmp);
	DLG_tmpMsgBox (
	    sbj->ev.mos.fr.x2, sbj->ev.mos.fr.y1,
	    DspCtrl.black, C_DLGBASE, COLMIX(C_INFO,C_GRAY),
	    " Free memory size %u (%s) byte(s) ", f, tmp );

	return (_EVT_NOTHING);
}

/*************************************************************************
*	TCh[N
*************************************************************************/
int		APL_sidework(int evtNo, EVTSBJ_T *sbj)
{
	extern	int		SideWorkMenu(void);

	SideWorkMenu();
	return (_EVT_NOTHING);
}

/*************************************************************************
*	[SYSTEM]
*************************************************************************/
static	int		ZNS_system( int evtNo, EVTSBJ_T *sbj )
{
	enum	_mnu_ar
	{	_ABOUT,	_FREE,	_SIDEWORK,	_E_NUM
	};
	static	MNUOBJ_T		obj[_E_NUM] =
	{
		{ MNU_NOR, 'A', "About ZNSPLAY", NULL, 0, APL_about   , NULL },
		{ MNU_NOR, 'F', "Free memory"  , NULL, 0, APL_freeMem , NULL },
		{ MNU_NOR, 'S', "Sidework"     , NULL, 0, APL_sidework, NULL },
	};
	MNU_T	*mnu;
	int		x0, y0;

	x0 = sbj->ev.mos.fr.x1;
	y0 = sbj->ev.mos.fr.y1;

	mnu = MNU_open( x0, y0, MNUATT_EXIT, _E_NUM, obj, _SYSTEM_ );
	if ( mnu == NULL )
		return (EVT_BREAK);
	setMenuCol( mnu );
	evtNo = MNU_start ( mnu );
	MNU_close(mnu);

	return (evtNo);
}

/*************************************************************************
*	t@CI[v
*************************************************************************/
int		ZNS_open(void)
{
	int			ret;
	FDL_T		*fdl;
	char		*filename;

	DSP_writePage(1);
	if ( (fdl = ZnsFdl) == NULL )
	{
		if ( (fdl = FDL_open(0)) == NULL )
		{	/* error */
			return	(_EVT_NOTHING);
		}
		FDL_set_title( fdl, _ZNSPLAY_);
		FDL_set_wildcard( fdl, ZNS_WILD_ALL );
		ZnsFdl = fdl;
	}

	KBF_clear();
	if( (ret = FDL_start( fdl )) == NORMAL )
	{
		filename = FDL_get_filename(fdl);
		if ( *filename == '\0' )
			return	(_EVT_NOTHING);
	} else
		return	(_EVT_NOTHING);
	strcpy( ZnsMove.filename, filename );
	zns_dsp_info();

	return	(_EVT_NOTHING);
}

/*************************************************************************
*	Đ
*************************************************************************/
int		zns_play( ZNSMOVE_T *znsmove )
{
	int			i;
	char		sub[128];
	static struct
	{	CONST char	sub[4];
		int			typ;
	} subtbl[] =
	{
		{"mov",	ZNS_TYP_MOV},
		{"v00",	ZNS_TYP_V00},
		{"v02",	ZNS_TYP_V02},
	};

	FS_getSnam( sub, ZnsMove.filename );

	znsmove->type = -1;
	for ( i = 0; i < sizeof(subtbl)/sizeof(*subtbl); ++i )
	{
		if ( strcmpi( sub, subtbl[i].sub) == 0 )
		{
			znsmove->type =  subtbl[i].typ;
			break;
		}
	}
	if ( znsmove->type < 0 )
		return (ERR);

	if ( znsmove->mode == ZNS_MODE_DISK )
	{	/* fBXNĐ[hłBGM ~	*/
		MID_playStop();
	}

	MOS_COFF();

	/* ~[g	*/
	int		mute;
	SND_get_elevol_mute(&mute);
	SND_elevol_mute(mute | 3);

	switch( znsmove->type )
	{
		case	ZNS_TYP_MOV:
		{
			zns_play_mov( znsmove );
			break;
		}
		case	ZNS_TYP_V00:
		case	ZNS_TYP_V02:
		{
			zns_play_v02( znsmove );
			break;
		}
	}

	/* ~[gݒ	*/
	SND_elevol_mute(mute & (~3));

	return (NORMAL);
}

/*************************************************************************
*	Đ
*************************************************************************/
int		ZNS_play(void)
{

	if ( ZnsMove.filename[0] == '\0' )
		return	(_EVT_NOTHING);

	if ( FS_isFileExist(ZnsMove.filename) != FS_EXIST_FILE )
	{	/* File not found */
		return	(_EVT_NOTHING);
	}
	zns_play ( &ZnsMove );

	return	(_EVT_NOTHING);
}


/*************************************************************************
*	[MENU]
*************************************************************************/
static	int		ZNS_menu( int evtNo, EVTSBJ_T *sbj )
{
	enum	_mnu_ar
	{	_MENU_OPEN,	_MENU_PLAY,	_MENU_NUM
	};
	static	MNUOBJ_T		obj[_MENU_NUM] =
	{
		{ MNU_NOR, 'O', "Open" , NULL, _MENU_OPEN, (int (*)())0, NULL },
		{ MNU_NOR, 'P', "Play" , NULL, _MENU_PLAY, (int (*)())0, NULL },
	};
	MNU_T	*mnu;
	int		x0, y0;

	x0 = sbj->ev.mos.fr.x1;
	y0 = sbj->ev.mos.fr.y1;

	mnu = MNU_open( x0, y0, MNUATT_EXIT, _MENU_NUM, obj, "MENU" );
	if ( mnu == NULL )
		return (EVT_BREAK);
	setMenuCol( mnu );
	evtNo = MNU_start ( mnu );
	MNU_close(mnu);
	switch ( evtNo )
	{	case	_MENU_OPEN:	evtNo = ZNS_open();	break;
		case	_MENU_PLAY:	evtNo = ZNS_play();	break;
	}

	return (evtNo);
}

/*************************************************************************
*	[SETUP]
*************************************************************************/
static	int		ZNS_setup( int evtNo, EVTSBJ_T *sbj )
{
	enum	_mnu_ar
	{	_MENU_MODE, _MENU_WAIT,	_MENU_EXPAND,	_MENU_NUM
	};
	static	MNUOBJ_T		obj[_MENU_NUM] =
	{
		{ MNU_STR, 'M', "Mode  %s"      , NULL, _MENU_MODE  , (int (*)())0, NULL },
		{ MNU_DIG, 'W', "Wait     [%2d]", NULL, _MENU_WAIT  , (int (*)())0, NULL },
		{ MNU_DIG, 'D', "Display [~%d]", NULL, _MENU_EXPAND, (int (*)())0, NULL },
	};
	MNU_T	*mnu;
	int		x0, y0;

	x0 = sbj->ev.mos.fr.x1;
	y0 = sbj->ev.mos.fr.y1;

	mnu = MNU_open( x0, y0, MNUATT_EXIT, _MENU_NUM, obj, _SETUP_ );
	if ( mnu == NULL )
		return (EVT_BREAK);
	setMenuCol( mnu );
	do
	{
		obj[_MENU_MODE  ].para = ZnsMove.mode == ZNS_MODE_MEMORY ? "[memory]" : "  [disk]";
		obj[_MENU_WAIT  ].para = (void *)(ZnsMove.wait);
		obj[_MENU_EXPAND].para = (void *)(ZnsMove.expand);

		evtNo = MNU_start ( mnu );
		switch( evtNo )
		{
			case	_MENU_MODE:
			{
				if ( ZnsMove.mode == ZNS_MODE_MEMORY )
					ZnsMove.mode = ZNS_MODE_DISK;
				else
					ZnsMove.mode = ZNS_MODE_MEMORY;
				break;
			}
			case	_MENU_WAIT:
			{
				int		ret, wait;
				DLG_T	*dlg;
				char	tmp[16];

				dlg = DLG_getsOpen( DLGPOS_MOS_SET_HOME, DLGPOS_MOS_SET_HOME, 320,
				    "WAIT 0`99 [%2d]", ZnsMove.wait );
				if ( dlg == NULL )
					break;
				DLG_getsSetTitle( dlg, "CHANGE WAIT" );
				tmp[0] = '\0';
				ret = DLG_getsStart( dlg, 8, tmp );
				if ( ret > 0 && (wait = atoi(tmp)) >= 0 && wait < 100 )
					ZnsMove.wait = wait;
				DLG_getsClose(dlg);
				break;
			}
			case	_MENU_EXPAND:
			{
				int		expand;
				static	MNUOBJ_T		expand_obj[4] =
				{
					{ MNU_NOR, '1', " ~1 ", NULL, 1, (int (*)())0, NULL },
					{ MNU_NOR, '2', " ~2 ", NULL, 2, (int (*)())0, NULL },
					{ MNU_NOR, '3', " ~3 ", NULL, 3, (int (*)())0, NULL },
					{ MNU_NOR, '4', " ~4 ", NULL, 4, (int (*)())0, NULL },
				};
				MNU_T	*expand_mnu;
				expand_mnu = MNU_open( DLGPOS_MOS_SET_HOME, DLGPOS_MOS_SET_HOME,
				    MNUATT_EXIT, 4, expand_obj, "DISPLAY" );
				if ( expand_mnu == NULL )
					break;
				setMenuCol( expand_mnu );
				expand = MNU_start ( expand_mnu );
				if ( expand >= 1 && expand <= 4 )
					ZnsMove.expand = expand;
				MNU_close(expand_mnu);
				break;
			}
		}
	} while ( evtNo >= 0 );
	MNU_close(mnu);

	zns_dsp_info();

	return	(_EVT_NOTHING);
}

int		APL_bgm(void)
{
	int			ret;
	FDL_T		*fdl;
	char		*filename;

	DSP_writePage(1);
	if ( (fdl = BgmFdl) == NULL )
	{
		if ( (fdl = FDL_open(0)) == NULL )
		{	/* error */
			return	(ERR);
		}
		FDL_set_title( fdl, _BGM_);
		FDL_set_wildcard( fdl, BGM_WILDCARD );
		BgmFdl = fdl;
	}

	if( (ret = FDL_start( fdl )) == NORMAL )
	{
		filename = FDL_get_filename(fdl);
		if ( *filename )
			MID_playStart(filename);
	}

	return (NORMAL);
}

int		APL_stop(void)
{
	MID_playStop();
	return (NORMAL);
}

/*************************************************************************
*	[TOY-BOX]
*************************************************************************/
static	int		ZNS_toybox( int evtNo, EVTSBJ_T *sbj )
{
	enum	_mnu_ar
	{	_BGM_PLAY,	_BGMSTOP,	_E_NUM
	};
	static	MNUOBJ_T		obj[_E_NUM] =
	{
		{ MNU_NOR, 'P', "BGM Play", NULL, 0, APL_bgm    , NULL },
		{ MNU_NOR, 'S', "BGM Stop", NULL, 0, APL_stop   , NULL },
	};
	MNU_T	*mnu;
	int		x0, y0;

	x0 = sbj->ev.mos.fr.x1;
	y0 = sbj->ev.mos.fr.y1;

	mnu = MNU_open( x0, y0, MNUATT_EXIT, _E_NUM, obj, _TOY_BOX_ );
	if ( mnu == NULL )
		return (EVT_BREAK);
	setMenuCol( mnu );
	evtNo = MNU_start ( mnu );
	MNU_close(mnu);

	return (evtNo);
}


/*************************************************************************
*	[EXIT]
*************************************************************************/
int		mainExit(int evtNo, EVTSBJ_T *sbj )
{
	return (_EVT_MAIN_EXIT);
}


#define	NUM_MENUBAR	(4)
static	MENUBAR	MenuBar[NUM_MENUBAR] =
{
	{ 1, 0xFFFF, 0xFF00, ZNS_system    , NULL, _SYSTEM_		},
	{ 2, 0xFFFF, 0xFF00, ZNS_menu      , NULL, " MENU "		},
	{ 3, 0xFFFF, 0xFF00, ZNS_toybox    , NULL, _TOY_BOX_	},
	{ 4, 0xFFFF, 0xFF00, ZNS_setup     , NULL, _SETUP_		},
};

static	EVT_T		*EvtPtr   = NULL;
static	EVT_T		*MbarEvt  = NULL;

/*************************************************************************
*	ZNSPLAY 
*************************************************************************/
static int		zns_init(void)
{
	int		evtPos = 0;

	MOS_COFF();
	DSP_writePage(1);
	/* AvʃCxgݒ	*/
	EvtPtr = EVT_alloc(NULL,_EVT_NUM);

	/* [SIDEWORK]	*/
	_EVT_SETKEY( EvtPtr, evtPos++, _EVT_SIDEWORK, KEYEVT_SHIFT,
	            0xFFFF, KA_ESC|KA_BIT_CTRL, APL_sidework, NULL );

	/* [EXIT] {^	*/
#define	SC	DspCtrl.scinf[1].sc
	{
		MNUSETBTN_T	para =
		{
			{	evtPos++, _EVT_MAIN_EXIT,
				DspCtrl.writePage,
				MOSEVT_BTN, BTN_LEFT,
				{ SC.x2-43, 5, (SC.x2-43)+40-1,5+14-1 },
				mainExit, NULL,
			},
			8,ERR,
			C_HRED,C_MBLACK,C_WHITE,C_HBLACK
		};
		MNU_evtSetBtn( EvtPtr, &para, "EXIT" );
	}

	/* Cj[o[	*/
	MbarEvt =
	    SetMenuBar ( EvtPtr, 6, 5, C_YELLOW, C_MBLACK, C_WHITE, C_HBLACK,
	        NUM_MENUBAR, MenuBar );

	MOS_curType(MOSCUR_NORMAL);

	zns_dsp_info();

	return (NORMAL);
}

/*************************************************************************
*	ZNSPLAY I
*************************************************************************/
static void	zns_term(void)
{
	if ( BgmFdl )		FDL_close( BgmFdl );
	if ( ZnsFdl )		FDL_close( ZnsFdl );
	if ( EvtPtr )		EVT_free( EvtPtr );
}

/*************************************************************************
*	ImF
*************************************************************************/
static	int		exitCheck(void)
{
	int		ret;
	enum	_sure_ar {_SURE_EXIT,_SURE_CANCEL,_SURE_BTN_N};
	static	SELBTNOBJ_T	obj[_SURE_BTN_N] =
	{
		{ 0, " CLOSE " , '\r'  , KA_EXEC  , _SURE_EXIT  +1, (int (*)())0, NULL},
		{ 0, " CANCEL ", '\x1B', KA_CANCEL, _SURE_CANCEL+1, (int (*)())0, NULL},
	};
#define	_SURE_MSG	"\
    Do you want to close %s ?    \
\n[s]  CLOSE \
\n[]  CANCEL\
"

	DSP_writePage(1);
	ret =  MENU_selectBtn( DLGPOS_CENTER_OF_SCN, DLGPOS_CENTER_OF_SCN,
		   DspCtrl.black, C_DLGBASE, COLMIX(C_WARNNING,C_GRAY),
		   SELBTN_ATT_CENTER, _SURE_BTN_N, obj, _SURE_MSG, _ZNSPLAY_ ) - 1;
	if ( ret == _SURE_EXIT )
		return (TRUE);
	else
		return (FALSE);
}

/*************************************************************************
*	main loop
*************************************************************************/

void	zns_main(void)
{
	zns_init();

#if	0
	if ( ZnsMove.filename[0] )
	{
		if ( FS_isFileExist(ZnsMove.filename) == FS_EXIST_FILE )
		{
			zns_play( &ZnsMove );
		}
		if ( FlagQuickRet )
			goto _RET;
	}
#endif

	for(;;)
	{
		int		ret;

		MOS_CON();
		ret = EVT_chk( EvtPtr, 0 );
		if ( ret == _EVT_MAIN_EXIT )
		{	if ( exitCheck() )
				break;	/* I	*/
		}
	}
_RET:
	zns_term();
}
